lw=2; %axis line width
plw=3; %plot line widt
blw=6; %baseline line width
fs = 16; %font size

%% Figure 3B

%==========================================================================
% In order to generate figures, either load pre-processed variables below...
%==========================================================================
load('Fig3.mat')


%==========================================================================
% Or uncomment the following lines after running QG_initialise.m:
%==========================================================================
% for sub=1:10
%     for mc=1:5
%         TrDat=TrialData(mc,sub);
%         FrDat=FrameData(mc,sub);
%         trind=0;
%         for tr=1:880
%             if TrDat.PertCond(tr) < 25
%                 trind=trind+1;
%                 PY = (FrDat.PY(tr,:)+17.5)*4;
%                 VY = FrDat.VY(tr,:);
%                 for loc = 0.25:0.25:100
%                     ind=find(PY>loc, 1);
%                     if ~isempty(ind)
%                         posY(sub, mc, trind, loc*4) = PY(ind);
%                         velY(sub, mc, trind, loc*4) = VY(ind);
%                     else
%                         posY(sub, mc, trind, loc*4) = NaN;
%                         velY(sub, mc, trind, loc*4) = NaN;
%                     end
%                 end
%             end
%         end
%     end
% end


figure(1)
subplot(1,2,1)

h=plot(squeeze(mean(mean(posY, 1), 3))', squeeze(mean(mean(velY, 1), 3))', 'LineWidth', plw);

h(2).Color = h(5).Color;
h(5).Color = [150,150,150]/255;
h(5).LineWidth=blw;

xlim([0, 100])
ylim([0, 60])
yticks([0, 20, 40, 60])
xticks([0, 20, 40, 60, 80, 100])

xlabel('position (%)')
ylabel('velocity (cm/s)')
set(gca, 'LineWidth', lw, 'Fontsize', fs, 'tickdir', 'out')
% offsetAxes;
box off

%% Figure 3C: all gains ( may need to run QG_initialise before)
subplot(1,2,2)
h=errorbar(squeeze(mean(vmGain, 1))', squeeze(std(vmGain, [], 1))'/sqrt(10), 'LineWidth', plw);

h(2).Color = h(5).Color;

h(5).Color = [150,150,150]/255;
h(5).LineWidth = blw;

xlim([0, 6])
ylim([0, 2])
yticks([0, 0.5, 1, 1.5 2])
yticklabels(['0'; ' '; ' '; ' '; '2'])
xticks(linspace(0,6, 6))
xticklabels([' 0 ';'20 ';'40 ';'60 ';'80 ';'100'])

xlabel('hand distance [%]')
ylabel('x force [N]')
set(gca, 'LineWidth', lw, 'Fontsize', fs, 'tickdir', 'out')
% offsetAxes
box off



%% Plot Figure 7D

figure(3)
clm=colormap('lines');
clm=clm([1,5,5],:);
clm(3,:) = [150,150,150]/255;

set(groot,'defaultAxesColorOrder',clm)

errorbar(squeeze(mean(vmGain(:, [1,2,5], :), 1))', squeeze(std(vmGain(:, [1,2,5], :), [],1))'/sqrt(10), 'LineWidth', 3)


xlim([0, 6])
ylim([0, 2])
yticks([0, 0.5, 1, 1.5 2])
yticklabels(['0'; ' '; ' '; ' '; '2'])
xticks(linspace(0,6, 6))
xticklabels([' 0 ';'20 ';'40 ';'60 ';'80 ';'100'])

xlabel('position (%)')
ylabel('correction strength (N)')
set(gca, 'LineWidth', 2, 'Fontsize', 16)
box off
set(groot,'defaultAxesColorOrder','remove')
