%% Script to generate Supplementary Fig1

lw=2;       %   axis line width
plw=3;      %   plot line widt
blw=6;      %   baseline line width
fs = 16;    %   font size

pt=0;       %   flag to generate .SVG of plots
top=1;      %   flag for plots on the top (=1), bottom (=0)

%% computing. Requires full original data set (FrameData and TrialData). Skip this if the full set is not available.
for sub=1:10
    for mc=1:5
        for pc = 2:11
            force(sub, mc, pc-1, :) = squeeze(nanmean(FrameData(mc, sub).FX(TrialData(mc, sub).PertCond == pc,:)));
            tim(sub, mc, pc-1) = round(nanmean(TrialData(mc, sub).PertTime(TrialData(mc, sub).PertCond == pc))*1000);
        end
    end
end

for sub=1:10
    for mc=1:5
        for pc = 2:2:10
            force1(sub, mc, pc/2, :) = force(sub, mc, pc-1, :) - force(sub, mc, pc, :);
            tim1(sub, mc, pc/2) = (tim(sub, mc, pc-1)+tim(sub, mc, pc))/2;
        end
    end
end

for sub=1:10
    force1(sub, :,:,:) = force1(sub, :,:,:)/nanmean(nanmean(nanmean(force1(sub, :,:,:))));
end
force1=-force1;

for sub=1:10
    for mc=1:5
        for pc = 1:5
            t=round(tim1(sub, mc, pc));
            force2(sub, mc, pc, :) = force1(sub, mc, pc, (t):(t+399));
        end
    end
end


%%  Plotting
load('Supp1.mat')

clm=colormap('lines');
clm(2,:)=clm(5,:);
clm(5,:)=[150,150,150]/255;

for mc=1:5
    for pc=1:5
        if top
            f=-squeeze(nanmean(force2(:, mc, pc, :)))';
            se=squeeze(nanstd(force2(:, mc, pc, :)))'/sqrt(10);
        else
            f=-squeeze(nanmean(force1(:, mc, pc, 1:900)))';
            se=squeeze(nanstd(force1(:, mc, pc, 1:900)))'/sqrt(10);
            t=round(mean(squeeze(tim1(:, mc, pc))));
        end
        plot(f, 'Color', clm(mc, :))
        hold on
        fill([1:length(f), fliplr(1:length(f))], [f+se, fliplr(f-se)], clm(mc, :), 'FaceAlpha', 0.3)
        if ~top
            Yl=get(gca, 'Ylim');
            plot([t,t], Yl, '--k')
        end
    end
    if top
        fill([180,230,230,180], [Yl(1), Yl(1),Yl(2), Yl(2)], 'k', 'FaceAlpha', 0.1, 'EdgeAlpha', 0.0)   
    end
    xlabel('time (s)')
    ylabel('intensity (N)')
    set(gca, 'FontSize', fs, 'TickDir','out', 'LineWidth', lw)
%     offsetAxes
    box off
    if pt
        print(['Fig', num2str(mc)],'-dsvg')
    end
    pause
    
    hold off
end
