clear all

xCost=0.5;  %0.5
col= get(gca, 'Colororder');
col=[col;col];

close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% define parameters

% variable parameters
N = 80;                 % duration in number of time steps
VMtau=12;               % visuomotor delay. 120ms was used in Liu & Todorov, 2007

% might need changing
prm.c = [0.15, 0.05; -0.05, 0.15];          % control-dependent noise (adjust size by changing the scalar)
prm.r = 0.00001;                               % control signal penalty
Nsim = 40;

% definitely fixed parameters
prm.dt = 0.01;              % time step (sec) 
prm.m = 1.1;                  % mass of the hand (kg)
prm.b = 7;                 % damping (N/sec)
prm.tau = 0.05;             % time constant (msec)

prm.sigma = 0.015;            % sensory noise
prm.sa = 0.1;                 % relative penalty of final force compared to final velocity

prm.xcost=xCost;           % cost of X-error at the end
prm.ycost=1;                % cost of Y-error at the end
prm.v = 0.2;                 % endpoint velocity penalty (0.1 for hit the target not caring to really stop, 1 for stop at the target-y not caring to hit the target)
prm.f = prm.v/prm.sa;       % endpoint force penalty

Ty = 0.25;                  % target distance
Tx = 0.0;                   % initial target x-coordinate
TxPert=0.02;                % perturbed target x-coordinate

numPertLoc=[1,2,3,4,5]/6;       % locations of cursor jumps

t1 = 0.01;                  % beginning of VM window in seconds
t2 = 0.06;                  % end of VM window in seconds

% saving parameters for export
prm.N=N;
prm.VMtau = VMtau;
prm.Nsim = Nsim;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Simulating the experiments
% N : movement duration, taken from the previous simulations
% NS : times to target, taken for each perturbation from human participants
% data

fprintf('Baseline condition\n')
modelNo=3;
N=93;
NS=[71 62 56 53 55];
for p=1:5

    pll=0;
    kal_lqg_v2_TP
end
sims{modelNo}=simulations;
X1s{modelNo}=inState;
fprintf('\nLate peak condition\n')
modelNo=1;
N=105;
NS=[67 56 51 51 58];
for p=1:5
    pll=0;
    kal_lqg_cond1_TP
end
sims{modelNo}=simulations;
X1s{modelNo}=inState;
fprintf('\nEarly peak condition 2\n')
modelNo=2;
N=113;
NS=[100   94   86   80   75];
for p=1:5

    pll=0;
    kal_lqg_cond2_TP
end
sims{modelNo}=simulations;
X1s{modelNo}=inState;
%%
Fig7C_plot;
