clear all

tic

subNo=1;

% loop through three different hand kinematic simulations
% j = 1: baseline
% j = 2: late peak condition
% j = 3: early peak condition
for j=1:3

        
    Fig8_simulation         % run simulation for the current condition
    if subNo>1
        % extract gains for specific velocity from simulation data
        % if more than one participant simulated, average
        v80=mean(exportFX{1},1);    % 80 cm/s
        v70=mean(exportFX{2},1);    % 70 cm/s
        v60=mean(exportFX{3},1);    % 60 cm/s
        v50=mean(exportFX{4},1);    % 50 cm/s
        v40=mean(exportFX{5},1);    % 40 cm/s
    else
        % extract gains for specific velocity from simulation data
        v80=exportFX{1};
        v70=exportFX{2};
        v60=exportFX{3};
        v50=exportFX{4};
        v40=exportFX{5};
    end

    allG{j}=[v80, v70, v60, v50, v40];  % all gains vector, no matter velocity
    allT{j}=[timeV80, timeV70, timeV60, timeV50, timeV40]*10;   % all times to target (*10 to convert to ms)
    allT{j}(isnan(allT{j}))=0;
    allG{j}(isnan(allG{j}))=0;
    
    % sort for plotting
    [allT{j}, I] = sort(allT{j});
    allG{j}=allG{j}(I);
end

toc