close all
clear all
% clc


receding_bline
infinite_bline
clearvars -except dur_rec dur_inf gain_rec gain_inf vel pos
load('Fig5.mat')

% get mean data for the respective variables 
mvNeutMean=mean(mvNeut, 3);
mvTimeMean=mean(mvTime, 4);
pTimeMean=mean(pTime, 4);

% combine left and right
mvTimeMeanLR=(mvTimeMean(:,:,[1,3,5,7,9])+mvTimeMean(:,:,[1,3,5,7,9]+1))/2;
pTimeMeanLR=(pTimeMean(:,:,[1,3,5,7,9])+pTimeMean(:,:,[1,3,5,7,9]+1))/2;


% export to a structure for later (ov)
S.MovementDurations=squeeze(mean(mvTimeMeanLR));
S.PerturbationTimes=squeeze(mean(pTimeMeanLR));
S.TimesToTarget=squeeze(mean(mvTimeMeanLR))-squeeze(mean(pTimeMeanLR));

%% Figure 5A
clm=colormap('lines');
clm=clm([1,5,5], :);
clm(3,:)=[0.8,0.8,0.8];
clm=[0.8,0.8,0.8];

figure(1)
bline=squeeze(mvTimeMeanLR(:,3,:));


barvals=squeeze(mean(bline));
barse=squeeze(std(bline))/sqrt(10);

% formatting below
hold on
nbars=5;
ngroups=1;

groupwidth = min(0.8, nbars/(nbars + 1.5));
X=[];
for i = 1:nbars
    % Calculate center of each bar
    x = (1:ngroups) - groupwidth/2 + (2*i-1) * groupwidth / (2*nbars);
    X=[X, x];
end
b=bar(X, barvals, 'FaceColor', 'flat', 'linewidth', 2, 'EdgeAlpha', 0);
errorbar(X, barvals(:,:), barse(:,:), '.k', 'linewidth', 1.5, "MarkerSize", 0.001)


for i=1:5
    b.CData(i,:)=(clm/((i-0.1).^.6));
end

ylim([0, 1.5])
yticks([0, 0.5, 1, 1.5])

xticks([0.5,1,2,3])
xticklabels([{' '};{'baseline'}; {''}; {''}])
set(gca, 'LineWidth', 2, 'Fontsize', 16, 'TickDir', 'out')
box off
% offsetX
ylabel('movement time (s)')
b(1).BaseLine.LineStyle='none';

%% add receding and infinite horizon times

plot(X, dur_rec(1:5), 'k.--', 'MarkerSize', 15, 'LineWidth', 2)
plot(X, dur_inf(1:5), 'k.-.', 'MarkerSize', 15, 'LineWidth', 2)

model_gains_bline

figure
plot(0.25+pos{1}, vel{1}, 'k-.', 'MarkerSize', 15, 'LineWidth', 2); 
hold on; 
plot(pos{2}, vel{2}, 'k--', 'MarkerSize', 15, 'LineWidth', 2)