clearvars -except dur_rec dur_inf gain_rec gain_inf vel pos

pOnsDs=[1,2,3,4,5, 5.8]/6;
VMtau=12;

prm.c = [0.15, 0.05; -0.05, 0.15]*1;          % control-dependent noise (adjust size by changing the scalar)
prm.r = 0.0002;                               % control signal penalty
qScale=1;
Nsim = 40;

prm.dt = 0.01;              % time step (sec) 
prm.m = 1.1;                  % mass of the hand (kg)
prm.b = 7;                 % damping (N/sec)
prm.tau = 0.05;             % time constant (msec)

prm.sigma = 0.015;            % sensory noise
prm.sa = 0.1;                 % relative penalty of final force compared to final velocity

prm.xcost=1;            % cost of X-error at the end
prm.ycost=1;                % cost of Y-error at the end
prm.v = 0.02;                 % endpoint velocity penalty (0.1 for hit the target not caring to really stop, 1 for stop at the target-y not caring to hit the target)
prm.f = prm.v/prm.sa;


A= zeros (6, 6);
A(1,3)=1;
A(2,4)=1;
A(3,3)=-prm.b/prm.m;
A(4,4)=-prm.b/prm.m;
A(3,5)= 1/prm.m;
A(4,6)= 1/prm.m;
A(5,5)= -1/(prm.tau);  %tau in seconds
A(6,6)= -1/(prm.tau);

B = zeros(6,2);
B(5,1) = 1/(prm.tau);
B(6,2) = 1/(prm.tau);


H = eye(6);  

C= prm.c;
Y= [0,0;0,0;0,0;0,0;C];
D0 = diag([1,1,1,1,1/prm.sa, 1/prm.sa])*prm.sigma;

R=prm.r*eye(2)*1;

Q=[prm.xcost, 0, 0, 0, 0, 0;
    0, prm.ycost, 0, 0, 0, 0;
    0, 0, prm.v, 0, 0, 0;
    0, 0, 0, prm.v, 0, 0;
    0, 0, 0, 0, 0, 0;
    0, 0, 0, 0, 0, 0;]*qScale;

G = diag([0.1, 0.1, 1, 1, 0, 0]);


% P12=rand(6);
% P22=rand(6);
% P11=rand(6);
% S22=rand(6);
% S11=rand(6);
% 
% 
% P=[P11, P12; P12, P22];
% S=[S11, zeros(size(S11));
%     zeros(size(S11)), S22];
rng(100)

K=rand(6);
L=rand(2, 6);


for k=1:200
    V=[Q+L'*R*L, -L'*R*L;
        -L'*R*L, L'*R*L+D0];

    Ad=[A-B*L, B*L; zeros(size(B*L)), A-K*H];
    Yd=[-Y*L, Y*L; -Y*L, Y*L];
    Gd = [G, zeros(6); G, -K*D0];
    
    KronTemp = kron(eye(12),Ad') + kron(Ad', eye(12)) + kron(Yd', Yd');

    vecS=KronTemp\reshape(-V, 144,1);
    S=reshape(vecS, 12, 12);

    S(7:12, 1:6) = 0;
    S(1:6, 7:12) = 0;
    S11=S(1:6, 1:6);
    S22=S(7:12, 7:12);
    
    KronTemp = kron(eye(12),Ad) + kron(Ad, eye(12)) + kron(Yd, Yd);
    vecP=KronTemp\reshape(-Gd*Gd', 144,1);
    
    P=reshape(vecP, 12, 12);
    P12= P(7:12, 1:6);
    P11=P(1:6, 1:6);
    P22=P(7:12, 7:12);
    
    K=P22*H'*inv(D0*D0');
    L=inv(R+Y'*(S11+S22)*Y)*B'*S11;
end
%%

contSys=ss(A-B*L, zeros(6,2),H,0);
discSys=c2d(contSys, prm.dt);
[A, B, H, ~]=ssdata(discSys);

pt=0;
for pOnsD = pOnsDs
    Xa = zeros(size(A,1),100);
    Xa(:,1) = [0.00, -0.25, 0, 0, 0, 0];
    Xtarg=zeros(1, 200);
    pt=pt+1;
    k=1;
    firstTime=1;
    secondTime=1;
%     TargDist = 0.25;
    Ty = 0.25;
    TxPert=0.02;
    trover=0;
    counter=0;
    while ~trover
        Xa(:,k+1) = A*Xa(:,k);
        if Ty + Xa(2,k+1) > pOnsD*Ty
            if firstTime
                
                firstTime=0;
                pOnsT=k+1;
            end
            
            if (k >= pOnsT+VMtau) & secondTime
                secondTime=0;
                Xa(1,k+1) = Xa(1,k+1)+TxPert; 
                Xtarg(k+1)=TxPert;
            elseif (k > pOnsT+VMtau)
                    Xtarg(k+1)=TxPert;
            end
        end
        
        k=k+1;
        if norm(Xa(1:2, k)) < 0.004
            counter=counter+1;
            if counter > 60
                trover = 1;
            end
        else
            counter = 0;
        end
    end
    k=k-counter+1;
    fprintf("Pert @ k=%d, duration=%d, ttt=%d\n", pOnsT, k, k-pOnsT)
    dur_inf(pt)=k/100;
    
    gain_inf(pt) = -mean(Xa(5, (pOnsT+VMtau+1):(pOnsT+VMtau+6)));
end

vel{1}=Xa(4,:);
pos{1}=Xa(2,:);