load('Fig11A');

% inside the data file are the following variables:
% X(mc, pl) : 5 x 5 array of times to target for condition x perturbation
% location in channel trials, averaged across participants
% Y(mc, pl) : visuomotor feedback gains in channel trials (matching with X
% SE(mc, pl) : standard errors in channel trials, matching X and Y
%
% X1, Y1, SE1 : same as X, Y and SE, but in maintained perturbation trials


col=colormap('lines');
col(2,:)=col(5,:);
col(5,:)=[150,150,150]/255;

lw=2; %axis line width
plw=2; %plot line widt
blw=1; %baseline line width
mlw=2; %model line width
fs = 16; %font size


% for mc=1:5 %here is gains from acceleration
%     errorbar(-(X(mc, :) +X1(mc,:))*1000/2, Y1(mc,:), SE1(mc,:), 'x', 'color', col(mc,:), 'LineWidth', plw);
%     hold on
% end
for mc=[1,2,3,4,5] %here are gains (from force)
    % we calculate "expected times to target" for each condition by
    % averaging times in channel trials with maintained perturbation trials
    % (these are different, and presented at a 50:50 ratio to participants
    % in the experiment)
    % We use the gains from channel trials only, as this is a more accurate
    % measure.
    errorbar(-(X(mc, :) +X1(mc,:))*1000/2, Y(mc,:), SE(mc,:), 'o', 'color', col(mc,:), 'LineWidth', plw);
    hold on
end

set(gca, 'LineWidth', lw,...
    'Fontsize', fs, 'TickDir','out',...
    'FontName','Helvetica Neue',...
    'FontWeight','normal',...
    'FontUnits','points');
box off
xticks([-1200, -1000, -800, -600, -400, -200, 0])
xticklabels([1200, 1000, 800, 600, 400, 200, 0])

yticks([0, 0.5, 1, 1.5, 2])

xlim([-1200, 0])
ylim([0, 2])
% offsetAxes

