
initialiseSSM                   % compute system dynamics and cost matrices
paras=[3.05978636125474,0.278458879743272,-0.591693291313749]; %obtained from optimisation previously
Rscale=exp(paras(1).*linspace(paras(2), paras(3), N)); %
Rscale=Rscale./mean(Rscale);

for k=1:N
    R{k}=R{k}*Rscale(k)*[1,0;0,1];
end     

% pos = positionProfile(A,B,Qf, R, X1, N);    % estimate movement profile with no perturbations
% time = convert_d2t(numPertLoc, pos);        % obtain times for each perturbation


% simulate neutral reaching
[K,L,Cost,Xa,XSim,Xhat,CostSim, Un] = kalman_lqg_pert( A,B, H, 0, ...
        D0.^D0, Qt,R, X1,0, Nsim, 1, 15, C, 50, 0.0, 0);
    
    
pos=Xa(2,:);
time = convert_d2t(numPertLoc, pos);

neutralF=(mean(squeeze(XSim(5,:,:))));  % calculate neutral (baseline) x-force of reaching in no perturbation

%% simulate everything
for pt=1:length(time)
    Tpert=time(pt)+VMtau;
    
    [K,L,Cost,Xa,XSim,Xhat,CostSim, Un] = kalman_lqg_pert( A,B, H, 0, ...
        D0.^D0, Qt,R, X1,0, Nsim, 1, 15, C, Tpert, TxPert, 0);
    
    simulations{pt} = XSim;
    controlInputs{pt} = Un;
    simulations{pt}(5,:,:) = simulations{pt}(5,:,:)-reshape(neutralF, 1,1,N);
end


%% calculate feedback gains
fbgtime = [t1/prm.dt+VMtau t2/prm.dt+VMtau];
fbgIntervals = ones(length(time),2);
fbgIntervals(1,:) = fbgIntervals(1,:) .* fbgtime(1);
fbgIntervals(2,:) = fbgIntervals(2,:) .* fbgtime(2);
fbgIntervals(:,1) = fbgIntervals(:,1) + fbgtime(1);
fbgIntervals(:,2) = fbgIntervals(:,2) + fbgtime(2);
 
rel_pos = numPertLoc * 100;     % convert to percent
 
for i = 1 : length(time)
    fbgIntervals(i,:) = [time(i)+fbgtime(1), time(i)+fbgtime(2)];
end
 
for i = 1 : length(simulations)
    for ii = 1 : Nsim
        if fbgIntervals(i,2) > N    % set gain to zero if trial ends before the feedback window
            FbG(ii) = 0;
        else
            FbG(ii) = mean(simulations{i}(5,ii,[fbgIntervals(i,1), fbgIntervals(i,2)]));
        end
    end
    FeedbackGains(i, :) = FbG;
    FbG = [];
end


fbgMeans = mean(FeedbackGains,2);
fbgStds = std(FeedbackGains, [], 2)/sqrt(Nsim);

for pt=1:length(time)
    exportVY{modelNo}(sub, pt, :) = mean(squeeze(simulations{pt}(4,:,:)));
    exportPX{modelNo}(sub, pt, :) = mean(squeeze(simulations{pt}(1,:,:)));
    exportPY{modelNo}(sub, pt, :) = mean(squeeze(simulations{pt}(2,:,:)));
    
end
exportFX{modelNo}(sub, :) = fbgMeans;
