

initialiseSSM                   % compute system dynamics and cost matrices

% simulate neutral reaching
[K,L,Cost,Xa,XSim,Xhat,CostSim, Un] = kalman_lqg_pert( A,B, H, 0, ...
        D0.^D0, Qt,R, X1,0, Nsim, 1, 15, C, 50, 0.0, 0);
    
Xa1 = Xa(2, :);
for j=1:5
    time(j)=find(Xa1 > numPertLoc(j)/4, 1);
end
    
neutralF=(mean(squeeze(XSim(5,:,:))));  % calculate neutral (baseline) x-force of reaching in no perturbation

% from neutral reaching extract the state at the time of perturbation to
% use as the initial state in the perturbed reaching
inState=Xa(:, time);


% transform the time to target in the rest of the movement (post
% perturbation), as well as get new Q and R
for t=(time(p)+1):N
    Rnew{t-time(p)}=R{t};
end
for t=(N+1):(N+ time(p))
    Rnew{t-time(p)}=R{N};
end
Qnew=Qt(:,:,(N-NS(p)+1):N);
R=Rnew;
Qt=Qnew;

%% simulate everything
Tpert=VMtau;
X1=inState(:,p);

[K,L,Cost,Xa,XSim,Xhat,CostSim, Un] = kalman_lqg_pert( A,B, H, 0, ...
    D0.^D0, Qt,R, X1,0, Nsim, 1, 15, C, Tpert, TxPert, 0);

simulations{p} = XSim;
controlInputs{p} = Un;
simulations{p}(5,:,:) = simulations{p}(5,:,:)-reshape(neutralF(N-NS(p)+1:end), 1,1,NS(p));


%% calculate feedback gains
fbgtime = [t1/prm.dt+VMtau t2/prm.dt+VMtau];
FbGains = squeeze(simulations{p}(5,:,fbgtime(1):fbgtime(2)));
fbgMeans =mean(mean(FbGains));


exportVY{modelNo, p} = mean(squeeze(simulations{p}(4,:,:)));
exportPX{modelNo, p} = mean(squeeze(simulations{p}(1,:,:)));
exportPY{modelNo, p} = mean(squeeze(simulations{p}(2,:,:)));
    
exportFX{modelNo}(p) = fbgMeans;
