function [pert_time] = convert_d2t(num_pert_loc,position)
% The script estimates the perturbation onset time from perturbation onset
% position, for the use in LQG.
%
% [pert_time] = convert_d2t(num_pert_loc,position)
% pert_time - perturbation onset time
% num_pert_loc - perturbation onset location
% position - time vector of Y position


trajectory_duration = length(position); % in ms
trajectory_length = max(floor(position*100)/100); 
pert_position = num_pert_loc.*trajectory_length;

for i = 1:length(pert_position)
    position_distance_to_pert_position = abs(position-pert_position(i));
    pert_time(i) = find(position_distance_to_pert_position==...
        min(position_distance_to_pert_position),1,'first');
end
