% Here we initialise the state-space representation of the system (LQG
% controlled forward movement with lateral target jumps

A= zeros (8, 8);
A(1,3)=1;
A(2,4)=1;
A(3,3)=-prm.b/prm.m;
A(4,4)=-prm.b/prm.m;
A(3,5)= 1/prm.m;
A(4,6)= 1/prm.m;
A(5,5)= -1/(prm.tau);  %tau in seconds
A(6,6)= -1/(prm.tau);

B = zeros(8,2);
B(5,1) = 1/(prm.tau);
B(6,2) = 1/(prm.tau);

H = zeros(8,8);
H(1:6,1:6) = eye(6);  

contSys=ss(A,B,H,0);
discSys=c2d(contSys, prm.dt);
[A, B, H, ~]=ssdata(discSys);

C= prm.c;
D0 = diag([1,1,1,1,1/prm.sa, 1/prm.sa,0,0])*prm.sigma;

X1 = zeros(8,1);
X1(7) = Tx;
X1(8) = Ty;

S1 = zeros(size(A));

for i = 1:N
    R{i} = prm.r/(N)*eye(2);
end



Qt = zeros([size(A),N]);

%set the end point costs
d = zeros(6,8);
d(1,1) = prm.xcost;
d(2,2) = prm.ycost;
d(1,7) = -prm.xcost;
d(2,8) = -prm.ycost;
d(3,3) = prm.v;
d(4,4) = prm.v;
d(5,5) = prm.f;
d(6,6) = prm.f;
Qf = d'*d;
for n=N:N
    Qt(:,:,n)=Qf;  
end
d = zeros(6,8);
d(1,1) = prm.xcost;
d(2,2) = prm.ycost;
d(1,7) = -prm.xcost;
d(2,8) = -prm.ycost;
d(3,3) = prm.v;
d(4,4) = prm.v;
d(5,5) = prm.f;
d(6,6) = prm.f;

Qt(:,:,N)=d'*d;